<template lang="pug">
  .container-detail
    BaseText.stock-detail-title-space-bottom(size='text-md') {{detail.rusAlias[0].toUpperCase() + detail.rusAlias.slice(1)}}
    BaseText.stock-detail-cost-of-sale-space-bottom(size='text-md-small' skin='grey' weight='weight500') Стоимость: {{detail.costOfSale}} монет
    BaseText.stock-detail-quantity-space-bottom(size='text-md-min-line-height') {{detail.quantityStock}} шт.
    BaseButton(
      size='small'
      skin='sell'
      @click='sell(detail)'
      :disabled='isNoDetails(detail)'
    ) Продать
</template>

<script lang='ts'>
import { Vue, Prop, Component } from 'vue-property-decorator'

import { PurseModule } from '../../store/modules/purse/index'
import { ProductionModule } from '../../store/modules/production/index'
import IDetail from '../../store/modules/production/interfaces'
import BaseButton from '../BaseButton.vue'
import BaseText from '../BaseText.vue'

@Component({
  components: {
    BaseButton,
    BaseText
  }
})
export default class DetailStock extends Vue {
  @Prop() detail!: IDetail
  @Prop() isShowModal!: boolean

  get details () {
    return ProductionModule.details
  }

  get coins () {
    return PurseModule.coins
  }

  get showModal () {
    return this.isShowModal
  }

  set showModal (value) {
    this.$emit('update:isShowModal', value)
  }

  sell (detail: IDetail) {
    if (detail.costOfSale + this.coins > 100) {
      this.showModal = true
    } else {
      PurseModule.addCoins(detail.costOfSale)
      ProductionModule.sell(detail.alias)
      for (let i = detail.quantityProduction + detail.quantityStock; i >= 0; i--) {
        if (detail.installed[i] === true) {
          for (let j = i; j >= 0; j--) {
            if (detail.installed[j] === false && i !== j) {
              detail.installed[i] = false
              detail.installed[j] = true
              break
            }
          }
          break
        }
      }
    }
  }

  isNoDetails (detail: IDetail) {
    return detail.quantityStock === 0
  }
}
</script>

<style lang="scss" scoped>
@import '../../assets/styles/config/variables.scss';

.container-detail {
  width: 236px;
  display: flex;
  flex-direction: column;
  align-items: center;
}
</style>
